﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Type InvoiceLineItem (InvoiceID As Int, ItemName As String, ItemQty As Int)				'To define invoice line items
	Public LineItems() As InvoiceLineItem													'To Host invoice line Items

	Public bmLogo As Bitmap						'Logo displayed on the page header
	Public bmSDS As Bitmap						'My company Suredata Solutions
	Public G_Company As String					'Company populated from successful Login

	Public RemoteSQL As JdbcSQL
	Private driver As String = "net.sourceforge.jtds.jdbc.Driver"
	Private database As String="mobilesurehajj"
	Private jdbcUrl As String = "jdbc:jtds:sqlserver://192.82.254.147:1533;integratedSecurity=false;databaseName=" & database & ";"
	Private Username As String = "mobileSurehajj"
	Private Password As String = "mobileSurehajj"
	
	'------------- DB Variables ---------------------------
	'Fields to be read from the database.... After login
	'I will put here all variables which I need frequently after the main Database reading call 
	Public G_PassengerPhoto As Bitmap

End Sub

Sub Service_Create

	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	'Initially it is blank. When reading the passenger, it will be populated.
	G_PassengerPhoto.Initialize(File.DirAssets,"blank.jpg")

End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub


Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
'--------------------------------------------------------

#region SQL

	public Sub Connect
		RemoteSQL.Initialize2(driver, jdbcUrl, Username, Password)
	End Sub

	Sub CloseConnection
		RemoteSQL.Close
	End Sub

Sub Login(ID As Int,Name As String) As Boolean
	Dim bolReturn As Boolean
	bolReturn=True
	Try
		Connect
			
		Dim sf As JdbcResultSet = RemoteSQL.ExecQuery2("select * from login_user where login_id= ? and login_name=?", Array(ID,Name))
			
		Dim bolFound As Boolean=False					'To check if record is returned (Successful login) or not
		Do While sf.NextRow
			bolFound=True
			Log(sf.GetString("login_fullname"))
			G_Company=sf.GetString("company_name")		'To be used later in the system to define which company it belongs to
		Loop
		sf.Close

		bolReturn=bolFound
	Catch
		Log(LastException)
		bolReturn=False
		Return bolReturn
	End Try
	CloseConnection
	Return bolReturn
End Sub

Sub CreateInvoice(InvoiceCompany As String,Items() As InvoiceLineItem) As Boolean
		'This is an Example of how to save Invoice (Master Details) within a transaction
		'	It is using Stored procedures
		'	The Scripts to create the stored procedures and the tables are attached to the post
		'	The InvoiceLineItem type is declared in the top of this module
		Dim bolReturn As Boolean
		bolReturn=True
		Try
			Connect
			'Either all saved or NONE
			RemoteSQL.BeginTransaction
			Dim sf As JdbcResultSet = RemoteSQL.ExecQuery2("exec up_createInvoice ?,?",Array(InvoiceCompany, InvoiceCompany))
			
			Dim InvoiceNumber As Int						'To preserve temporarily the invoice ID for creating the related line Items
			Dim bolFound As Boolean=False					'To check if record is returned (Successful login) or not
			Do While sf.NextRow
				bolFound=True
				Log(sf.Getint("theID"))
				InvoiceNumber=sf.getint("theID")
			Loop
			sf.Close
			If bolFound Then 								'i.e. Invoice created
				Dim i As Int
				For i=0 To Items.Length-1					'Loop through the line items array
					RemoteSQL.ExecNonQuery("exec up_create_LineItem " & InvoiceNumber & ",'" & Items(i).ItemName & "'," & Items(i).ItemQty)
				Next
				
				RemoteSQL.TransactionSuccessful				'All is GOOD
			End If
			bolReturn=bolFound								'Success Flag
		Catch
			Log(LastException)
			RemoteSQL.Rollback								'Ooops something went wrong... Rollback the whole thing
			CloseConnection									'Close connection, exit returning fail flag

			bolReturn=False
			Return bolReturn	
		End Try
	CloseConnection											'Successful action.... close connection and return success
	Return bolReturn
End Sub

#End Region

'--------------------------------------------------------














